#define AOW_NWEPCOUNT       6
#define AOW_CLASSCOUNT      27
#define AOW_CWEPCOUNT       5
#define AOW_AMMOCOUNT       45
#define AOW_ALTWEPCOUNT     5
#define AOW_OWEPCOUNT       AOW_ALTWEPCOUNT
#define AOW_MWEPCOUNT       6
#define AOW_IWEPCOUNT       7
#define AOW_EARMORCOUNT     5
#define AOW_CARMORCOUNT     6
#define AOW_BUILDINGCOUNT   6

#define C4TYPECOUNT     2

int NOSVPURE_AOW_HELP = "Help for script 592:\n\
Usage: puke -592 [mode] [arg1] [arg2]\n\
\n\
Puke script -692 for a menu.\n\
Modes\n\
-----\n\
1  - Gives you ((arg2 << 16) + arg1) credits.\n\
2  - Gives you the weapons of a certain AOW2 class, with arg1 as the class index. If arg1 is 0, prints the class indexes.\n\
3  - Gives you all AOW2 weapons, and maxes out your ammo. If arg1 is 1, only give AOW2 weapons. If it's 2, only give NoSVPure-AOW weapons.\n\
4  - Maxes out your ammo.\n\
5  - Doubles your ammo capacity for everything, and maxes out your ammo.\n\
6  - Gives you every AOW2 armor type, and upgrades your firepower (just use instagib and godmode - \"puke -591 -1\" for details).\n\
7  - Toggles an AOW2 armor class, equal to arg1.\n\
8  - Gives you (arg1 * 50) XP.\n\
9  - Toggles credit accumulation, with the amount of credits you gain per second equal to arg1.\n\
10 - Random crate powerup, or a specific crate powerup if arg1 isn't 0.\n\
11 - Toggles updating/coercion of AOW2 and game variables.\n\
12 - Selects a nosvpure_aow weapon, based off of arg1. If it's 0, it gives you a list.\n\
13 - Infinite enhanced and remote C4s! Wheeeeeeeeeeeeeeeeeeeeeeee\n\
14 - Switch your IsRedand IsBlue items.\n\
15 - Allow spawn room terrorizing with normal AOW weapons.\n\
16 - Wreck a building.\n\
17 - Toggle a mech weapon on you.\n\
18 - Infinite ammo!\n\
19 - Give an 'alternate' AOW2 weapon.\n\
20 - Switch a player's team.\n\
\n\
  Crate Effects\n\
 ---------------\n\
1:  Armour upgrade    2:  Base miracle   3:  Chemical proof   4:  Firepower upgrade\n\
5:  Bonus credits     6:  Bonus XP       7:  Fire proof       8:  Stealth rifle\n\
9:  Iron curtain      10: Kamikaze       11: Plasma cannon    12: Resign\n\
13: Speed upgrade     14: Credits stolen 15: Time gun         29: Bomb\n\
35: Base crasher      37: Utility gun    39: Laser resistance 41: Explosive resistance\n\
43: Bullet resistance 45: Guardian       46: Berserk          47: Healing Radius\n\
49: Team revival      51: Chainsaw       53: Marine Beacon    55: Open deck\n\
57: Thermal cloaking  59: Lose weapons   61: Fatigue          63: Remote C4\n\
65: Blursphere        67: Random weapon";

int aowNewWeapons[AOW_NWEPCOUNT] =
{
    "C4Spammer", 
    "InstantRepairPistol",
    "CacheMaker",
    "MechMaker",
    "TurretMaker",
    "GeoMaker",
};

int aowClassNames[AOW_CLASSCOUNT] = 
{
    "Gunman & Harvester",
    "Engineer",
    "Minigunner",
    "Technician",
    "Flamer",
    "Rifleman",
    "Machinegunner",
    "Grenadier",
    "Rocketeer",
    "Stealth Trooper",
    "Gauss Gunner",
    "Chemist",
    "Shock Trooper",
    "Commando",
    "Shotgunner",
    "Kamikaze",
    "Sniper",
    "Constructor",
    "Demoman",
    "Medic",
    "Laser Minigunner",
    "Aerial Minigunner",
    "Tiberium Soldier",
    "Super Shotgunner",
    "Plasma Gunner",
    "Artilleryman",
    "Time Cop"
};

int aowClassWeapons[AOW_CLASSCOUNT][AOW_CWEPCOUNT] = 
{
    {"SubmachineGun", "IsHarvester", "", "", ""},
    {"RepairGun", "", "", "", ""},
    {"SubmachineGun", "GatlingGun", "", "", ""},
    {"ProxyMine", "SubmachineGun", "RepairGun", "RepairGunUpgrade", ""},
    {"Flamer", "", "", "", ""},
    {"Rifle", "", "", "", ""},
    {"SubmachineGun", "MachineGun", "", "", ""},
    {"Rifle", "Grenade_Launcher", "", "", ""},
    {"Rifle", "MissileLauncher", "", "", ""},
    {"StealthLaserRifle", "Knife", "", "", ""},
    {"Rifle", "GaussRifle", "", "", ""},
    {"SubmachineGun", "ChemicalSprayer", "", "", ""},
    {"SubmachineGun", "ShockRifle", "", "", ""},
    {"MissileLauncher", "GatlingGun", "Rifle", "GaussRifle", "EnhancedTimedC4"},
    {"Boomstick", "", "", "", ""},
    {"BombPack", "", "", "", ""},
    {"SniperRifle", "", "", "", ""},
    {"RepairGun", "UtilityGun", "", "", ""},
    {"ProxyMine", "RemoteC4", "Boomstick", "BombSquadGun", "EnhancedTimedC4"},
    {"Boomstick", "HealGun", "", "", ""},
    {"LaserChaingun", "", "", "", ""},
    {"JumpJetGatlingGun", "", "", "", ""},
    {"TiberiumAutoRifle", "", "", "", ""},
    {"DoubleShotgun", "", "", "", ""},
    {"PlasmaGun", "", "", "", ""},
    {"ArtilleryCannon", "IsArtillerySoldier", "", "", ""},
    {"MachineGun", "TimeGun", "", "", ""},
};

int aowAmmoTypes[AOW_AMMOCOUNT] =
{
    "NewClipAmmo", "MachineGunAmmo", "PhosphorusGrenadeAmmo", 
    "FragGrenadeAmmo", "RifleAmmo", "RifleGrenadeAmmo", "GrenadeAmmo", 
    "MissileAmmo", "LaserRifleAmmo", "GaussRifleAmmo", "ChemicalAmmo", 
    "ChemicalGrenadeAmmo", "GeneporiumCharge", "FlamerAmmo", 
    "PlasmaCannonAmmo", "ShotgunAmmo", "SniperAmmo", "Utility_Ammo", 
    "RemoteC4Ammo", "LaserChaingunAmmo", "TE21CalAmmo", "ArtilleryShellAmmo", 
    "JumpJetFuel",  "PlasmaRifleAmmo", "TimeGunAmmo", "Clip", "Shell", 
    "RocketAmmo", "Cell", "ArtilleryShellAmmo", "ShortRangeMissileAmmo",
    "NukeAmmo", "MechRocketAmmo", "Orca-MinigunAmmo", "Orca-RocketAmmo",
    "RavenAC2Ammo", "Raven-RocketAmmo", "Wolverine-MinigunAmmo",
    "Titan-80mmAmmo", "Titan-FlamerAmmo", "Wolverine-MinigunAmmo",
    "StealthCharge", "Nails", "NailBombs", "BloodRevolverAmmo",
};

int aowOtherWeapons[AOW_ALTWEPCOUNT] = 
{
    "Unarmed", "Handgun", "EagerBeaver", "PlasmaCannon", "AdminPistol",
};

int aowMechWeapons[AOW_MWEPCOUNT] = 
{
    "GuardianWeapons", "MadCatWeapons", "OrcaWeapons", "RavenWeapons",
    "TitanWeapons", "WolverineWeapons",
};

int aowMechNames[AOW_MWEPCOUNT] = 
{
    "Guardian", "Mad Cat", "Orca", "Raven", "Titan", "Wolverine",
};

int aowWeaponItems[AOW_IWEPCOUNT] = 
{
    "TimedC4", "EnhancedTimedC4", "IonCannonBeacon", "NuclearStrikeBeacon", "ProxyMine",
    "ProxyMineCount", "TimedC4Count",
};

int aowEArmors[AOW_EARMORCOUNT] = 
{
    "FireProof", "ChemicalProof", "LaserResistance", "ExplosiveResistance",
    "BulletResistance"
};

int aowCArmors[AOW_CARMORCOUNT] = 
{
    "Grade-1Armor", "Grade1Armor", "Grade2Armor", "Grade3Armor", "Grade4Armor",
    "Grade5Armor"
};

int aowPArmors[AOW_CARMORCOUNT] = 
{
    "PowerGrade-1Armor", "PowerGrade1Armor", "PowerGrade2Armor", "PowerGrade3Armor", "PowerGrade4Armor",
    "PowerGrade5Armor"
};

int c4Types[TEAMCOUNT][C4TYPECOUNT] = 
{
    {"TimedC4ThrownBlue", "TimedC4ThrownEBlue"},
    {"TimedC4Thrown",     "TimedC4ThrownE"},
    {"TimedC4ThrownBlue", "TimedC4ThrownEBlue"},
    {"TimedC4Thrown",     "TimedC4ThrownE"},
    {"TimedC4ThrownBlue", "TimedC4ThrownEBlue"},
    {"TimedC4Thrown",     "TimedC4ThrownE"},
    {"TimedC4ThrownBlue", "TimedC4ThrownEBlue"},
    {"TimedC4Thrown",     "TimedC4ThrownE"},
};

// barracks, refinery, research, warfactory, repair, obelisk
int BuildingKillScripts[TEAMCOUNT][AOW_BUILDINGCOUNT] =
{
    {101, 102, 103, 104, 105, 114},
    {201, 202, 203, 204, 205, 214},
    {-1,  -1,  -1,  -1,  -1,  -1},
    {-1,  -1,  -1,  -1,  -1,  -1},
    {-1,  -1,  -1,  -1,  -1,  -1},
    {-1,  -1,  -1,  -1,  -1,  -1},
    {-1,  -1,  -1,  -1,  -1,  -1},
    {-1,  -1,  -1,  -1,  -1,  -1},
};

int BuildingNames[AOW_BUILDINGCOUNT] = 
{
    "Barracks", "Refinery", "Research", "War Factory", "Repair Facility", "Obelisk"
};

int loopInterest[PLAYERMAX]     = {0};
int loopC4[PLAYERMAX]           = {0};
int loopSpawnRoom[PLAYERMAX]    = {0};
int loopInfiniteAmmo[PLAYERMAX] = {0};
int loopAir;

#define CACHEITEMC      4
#define CACHEMODEC      18
#define GEOMODEC        18
#define TURRETMODEC     7
#define MECHMODEC       10

int cacheItems[CACHEITEMC] = {"CacheMode", "GeoMode", "TurretMode", "MechMode"};
int cacheTops[CACHEITEMC]  = {CACHEMODEC,  GEOMODEC, TURRETMODEC, MECHMODEC};

int cacheModes[CACHEMODEC] = {"Super cache", "Mini refinery", "Health regen cache",
                              "Ammo regen cache", "C4 Box", "Full refill", "Proxy mines",
                              "5 credits", "100 credits", "200 credits", "750 credits",
                              "Elemental armors", "Powerup crate", "Beacon item (invisible)",
                              "Various AOW2 weapons", "Megasphere + Armor + 250 XP",
                              "Nuke beacon", "Ion beacon"};

int geoModes[GEOMODEC] = {"Sandbag", "Five sandbags", "10 sandbags", "10x3 sandbags",
                          "Razor wire", "Three razor wire", "Three steps up", "Nine steps up",
                          "Three steps down", "Nine steps down", "2x2 platform", "Spiral steps",
                          "Wall of steps", "Wide wall of steps", "5x5x5 block of steps", "8-long step line",
                          "Indefinitely long step wall", "Indefinitely long step path"};

int turretModes[TURRETMODEC] = {"Gun turret", "Klaxon turret", "Precision turret",
                                "Artillery turret", "Mech turret", "Repair turret", "Mini-Raven"};

int mechModes[MECHMODEC] = {"Mad Cat", "Raven", "Titan", "Wolverine", "Guardian (blursphere)",
                            "Orca (blursphere)", "Mad Cat (blursphere)", "Raven (blursphere)",
                            "Titan (blursphere)", "Wolverine (blursphere)"};

#define CHOICECOUNT_AOW 20
#define CRATECOUNT 68

int AOWMenuLevel[PLAYERMAX];

int AOWChoiceNames[CHOICECOUNT_AOW][3] = 
{
    {"Give credits",                        "Credit count",     "Credit count x 65536"},
    {"Give class weapons",                  "Class index",      ""},
    {"Give all AOW2 weapons + max ammo",    "Weapon mode",      ""},
    {"Max ammo",                            "",                 ""},
    {"Double ammo capacity for everything", "",                 ""},
    {"Gives all armor + upgrade firepower", "",                 ""},
    {"Toggle AOW2 armor class",             "Class index",      ""},
    {"Give XP",                             "XP x 50",          ""},
    {"Toggle credit accumulation",          "Credits/second",   ""}, 
    {"Crate",                               "Which crate",      ""},
    {"Toggle AOW2 variable coercion",       "",                 ""},
    {"Select NoSVPure_AOW weapon",          "Weapon index",     ""},
    {"Infinite C4s",                        "",                 ""},
    {"Swap IsRed and IsBlue",               "",                 ""},
    {"Spawn room terrorism",                "",                 ""},
    {"Building Devastation",                "Building index",   "Team index"},
    {"Mech Toggle",                         "Which mech",       ""},
    {"Infinite Ammo",                       "",                 ""},
    {"Give 'alternate' weapon",             "Weapon",           "Amount"},
    {"Switch team of player",               "Team",             "IDX"},
};

int AOWChoiceArgLimits[CHOICECOUNT_AOW][2][2] = 
{
    {{-32768, 32768},       {-32768, 32767}},
    {{0, AOW_CLASSCOUNT+1}, {0, 0}},
    {{0, 3},                {0, 0}},
    {{0, 0},                {0, 0}},
    {{0, 0},                {0, 0}},
    {{0, 0},                {0, 0}},
    {{0, AOW_CARMORCOUNT},  {0, 0}}, 
    {{0, 3250/50},          {0, 0}},
    {{0, 32768},            {0, 0}},
    {{0, CRATECOUNT+1},     {0, 0}},
    {{0, 0},                {0, 0}},
    {{0, AOW_NWEPCOUNT+1},  {0, 0}},
    {{0, 0},                {0, 0}},
    {{0, 0},                {0, 0}},
    {{0, 0},                {0, 0}},
    {{1, AOW_BUILDINGCOUNT+1},  {0, TEAMCOUNT+1}},
    {{0, AOW_MWEPCOUNT+1},  {0, 0}},
    {{0, 0},                {0, 0}},
    {{0, AOW_OWEPCOUNT+AOW_IWEPCOUNT+1}, {1, 32768}},
    {{0, TEAMCOUNT},        {0, PLAYERMAX+1}},
};

int CrateEffects[CRATECOUNT] = 
{
    "Armor upgrade",
    "Base miracle",
    "Chemical proof",
    "Firepower upgrade",
    "Bonus credits",
    "Bonus XP",
    "Fireproof",
    "Stealth rifle",
    "Iron curtain",
    "Kamimaze",
    "Plasma cannon",
    "Resign",
    "Speed upgrade",
    "Credits stolen",
    "Time gun",
    "Armor upgrade",
    "Bonus credits",
    "Fireproof",
    "Resign",
    "Speed upgrade",
    "Chemical proof",
    "Firepower upgrade",
    "Bonus XP",
    "Stealth rifle",
    "Iron curtain",
    "Kamikaze",
    "Plasma cannon",
    "Credits stolen",
    "Bomb",
    "Bomb",
    "Bomb",
    "Bomb",
    "Bomb",
    "Bomb",
    "Base crasher",
    "Kamikaze",
    "Utility gun",
    "Utility gun",
    "Laser resistance",
    "Laser resistance",
    "Explosive resistance",
    "Explosive resistance",
    "Bullet resistance",
    "Bullet resistance",
    "Guardian",
    "Berserk... sometimes",
    "Healing radius",
    "Healing radius",
    "Team revival",
    "Team revival",
    "Chainsaw",
    "Chainsaw",
    "Marine beacon",
    "Marine beacon",
    "Open deck",
    "Bomb",
    "Thermal cloaking",
    "Thermal cloaking",
    "Lose weapons",
    "Lose weapons",
    "Fatigue",
    "Fatigue",
    "Remote C4",
    "Remote C4",
    "Blursphere",
    "Blursphere",
    "Random weapon",
    "Random weapon"
};

