script 592 (int which, int a1, int a2) net
{
    int attempts, ahelp, arun, whichname, a1name, a2name;

    if (CanNoSVPure(0))
    {
        ACS_ExecuteWithResult(642, which, a1, a2);
        attempts = "does";
        ahelp = "checks";
        arun = "runs";
    }
    else
    {
        attempts = "tries to do";
        ahelp = "tries to check";
        arun = "tries to run";
    }

    if (which == 0)
    {
        Log(s:"[NoSV] [AOW] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:ahelp, s:" help.");
    }
    else if (which > 0 && which <= CHOICECOUNT_AOW)
    {
        which--;

        whichname = AOWChoiceNames[which][0];

        if (StrLen(AOWChoiceNames[which][1]) != 0)
        {
            a1name = StrParam(s:" (\"", s:AOWChoiceNames[which][1], s:"\" is ", d:a1, s:")");
        }
        else
        {
            a1name = "";
        }

        if (StrLen(AOWChoiceNames[which][2]) != 0)
        {
            a2name = StrParam(s:" (\"", s:AOWChoiceNames[which][2], s:"\" is ", d:a2, s:")");
        }
        else
        {
            a2name = "";
        }

        Log(s:"[NoSV] [AOW] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:attempts, s:" \"", s:whichname, s:"\"", s:a1name, s:a2name, s:".");
    }
    else
    {
        Log(s:"[NoSV] [AOW] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:arun, s:" script 592 (", d:which, s:", ", d:a1, s:", ", d:a2, s:").");
    }
}

script 642 (int which, int a1, int a2)
{
    int i, j, k, l;
    int className, armName;
    int credSec, credCount, credOver, credOverI;
    int logStr, intStr;
    
    int pln = PlayerNumber();
    int team = GetPlayerInfo(pln, PLAYERINFO_TEAM);

    int authed = authenticated[pln];
    
    switch (which)
    {
      case 1:
        ACS_ExecuteAlways(321, 0, a1 + (a2 << 16), 0, 0);  // script 321 = AOW's credit giving script
        if (authed) { Print(s:"Got ", d:(a1 + (a2 << 16)), s:" credits"); }
        break;
        
      case 2:
        if (a1 == 0)
        {
            logStr = "";
            SetHudSize(640, 480, 1);
            HudMessage(s:"Classes:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 540.0, 34.0, 4.0, 1.0);

            for (i = 0; i < AOW_CLASSCOUNT; i++)
            {
                j = cond(i%2, CR_LIGHTBLUE, CR_WHITE);
                k = 50.0 + (i * 11.0);

                intStr = StrParam(d:i+1);
                logStr = StrParam(s:logStr, s:padStringR(intStr, " ", 2), s:" - ", s:aowClassNames[i], s:"\n");

                HudMessage(d:i+1;  HUDMSG_FADEOUT, 49235+(i*3), CR_GOLD,  500.4, k, 4.0, 1.0);
                HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(i*3), CR_GREEN, 513.4, k, 4.0, 1.0);
                HudMessage(s:aowClassNames[i]; HUDMSG_FADEOUT, 49237+(i*3), j, 520.1, k, 4.0, 1.0);
            }

            HudMessage(s:logStr; HUDMSG_PLAIN|HUDMSG_LOG, 1, CR_WHITE, 0,0,0);
            HudMessage(s:""; HUDMSG_PLAIN, 1, CR_WHITE, 0,0,1);


            break;
        }
        else if ((a1 <= 0) || (a1 > AOW_CLASSCOUNT))
        {
            if (authed) { Print(s:"Invalid class: \cd", d:a1); }
            break;
        }
        
        className = giveAOWClassWeapons(a1-1);
        
        if (className == 0)
        {
            if (authed) { Print(s:"Invalid class: \cd", d:a1); }
        }
        else
        {
            if (authed) { Print(s:"You have gotten the weapons for the \cn", s:className, s:"\c-."); }
        }
        break;
        
      case 3:
        if (a1 == 0 || a1 == 2)
        {
            giveAOWNoSVWeapons();
        }
        
        if (a1 == 0 || a1 == 1)
        {
            giveAOWSpecialWeapons();
            for (i = 0; i < AOW_CLASSCOUNT; i++)
            {
                giveAOWClassWeapons(i);
            }
            maxAllAOWAmmo();
        }
        
        if (authed)
        {
            switch (a1)
            {
                case 0: Print(s:"All wepon get"); break;
                case 1: Print(s:"AOW2 wepon get"); break;
                case 2: Print(s:"NoSV wepon get"); break;
            }
        }

        break;
        
      case 4:
        maxAllAOWAmmo();
        if (authed) { Print(s:"Ammo capacities maxed"); }
        break;
        
      case 5:
        doubleAllAOWAmmo();
        maxAllAOWAmmo();
        if (authed) { Print(s:"Ammo capacities maxed and doubled"); }
        break;
        
      case 6:
        giveAOWArmors();
        giveAOWClassArmor(1);
        giveAOWClassArmor(2);
        giveAOWClassArmor(3);
        giveAOWClassArmor(4);
        giveAOWClassArmor(5);
        GiveInventory("PowerFirepowerUpgrade", 1);
        if (authed) { Print(s:"All armor given, firepower upgraded"); }
        break;
        
      case 7:
        armName = toggleAOWClassArmor(a1);
        if (authed) { Print(s:"Toggled armor ", s:armName); }
        break;
        
      case 8:
        if (a1 > 0)
        {
            if (authed) { Print(s:"You got ", d:a1*50, s:" XP"); }

            for (i = 0; i < a1; i++)
            {
                ACS_ExecuteAlways(324, 0, 1, 0, 0);
                Delay(1);
            }
        }
        else
        {
            if (authed) { Print(s:"invalid XP arg: ", d:a1); }
        }
        break;
        
      case 9:
        loopInterest[pln] = !loopInterest[pln];
        
        credSec = a1 << 16;
        
        while (loopInterest[pln] == 1)
        {
            credCount += (credSec / 35);
            credOver = credCount - ((credCount << 16) >> 16); // remove fractional part 
            
            if (credOver >= 1.0)
            {
                credOverI = credOver >> 16;
                ACS_ExecuteAlways(321, 0, credOverI, 0, 0);  // AOW's credit giving script
            }
            
            credCount -= credOver;
            
            Delay(1);
        }
        break;

      case 10:
        ACS_ExecuteAlways(309, 0, a1, 1);
        break;

      case 11:
        loopAir = !loopAir;

        if (loopAir)
        {
            ACS_Terminate(599, 0);
            ConsoleCommand("compat_limited_airmovement 0");
        }
        else { ACS_Execute(599, 0, 0,0,0); }

        if (authed) { Print(s:"Coercion/updating of variables is \cd", s:cond(loopAir, "OFF", "ON"), s:"\c-."); }
        break;

      case 12:
        if (a1 == 0)
        {
            logStr = "";
            SetHudSize(640, 480, 1);
            HudMessage(s:"Weapons:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 540.0, 34.0, 4.0, 1.0);

            for (i = 0; i < AOW_NWEPCOUNT; i++)
            {
                j = cond(i%2, CR_LIGHTBLUE, CR_WHITE);
                k = 50.0 + (i * 11.0);

                intStr = StrParam(d:i+1);
                logStr = StrParam(s:logStr, s:padStringR(intStr, " ", 2), s:" - ", s:aowNewWeapons[i], s:"\n");

                HudMessage(d:i+1;  HUDMSG_FADEOUT, 49235+(i*3), CR_GOLD,  500.4, k, 4.0, 1.0);
                HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(i*3), CR_GREEN, 513.4, k, 4.0, 1.0);
                HudMessage(s:aowNewWeapons[i]; HUDMSG_FADEOUT, 49237+(i*3), j, 520.1, k, 4.0, 1.0);
            }

            HudMessage(s:logStr; HUDMSG_PLAIN|HUDMSG_LOG, 1, CR_WHITE, 0,0,0);
            HudMessage(s:""; HUDMSG_PLAIN, 1, CR_WHITE, 0,0,1);
            break;
        }
        else if ((a1 <= 0) || (a1 > AOW_NWEPCOUNT))
        {
            if (authed) { Print(s:"Invalid weapon index: \cd", d:a1); }
            break;
        }

        i = aowNewWeapons[a1-1];

        if (!CheckInventory(i)) { break; }
        SetWeapon(i);

        SetHudSize(640, 480, 1);
        HudMessage(s:i; HUDMSG_FADEOUT, 49215, CR_GOLD, 320.4, 80.1, 2.0, 1.0);
        break;

      case 13:
        loopC4[pln] = !loopC4[pln];
        if (authed) { Print(s:cond(loopC4[pln], "Infinite C4!", "Finite C4.")); }

        while (loopC4[pln])
        {
            GiveInventory("EnhancedTimedC4", 1);
            GiveInventory("TimedC4Count", 4);
            GiveInventory("RemoteC4", 1);

            GiveInventory("TimedC4", 4);
            SetInventory("RemoteC4Ammo", 3);

            Delay(1);
        }
        break;

      case 14:
        if (CheckInventory("IsRed"))
        {
            TakeInventory("IsRed", 0x7FFFFFFF);
            GiveInventory("IsBlue", 1);
            if (authed) { Print(s:"You are now considered to be on the \chBlue\c- team."); }
        }
        else
        {
            TakeInventory("IsBlue", 0x7FFFFFFF);
            GiveInventory("IsRed", 1);
            if (authed) { Print(s:"You are now considered to be on the \cgRed\c- team."); }
        }
        break;

      case 15:
        loopSpawnRoom[pln] = !loopSpawnRoom[pln];
        if (authed) { Print(s:cond(loopSpawnRoom[pln], "You can now terrorise the spawn room.", "You are now a decent citizen again.")); }

        while (loopSpawnRoom[pln])
        {
            TakeInventory("IsInSpawnRoom", 1);
            Delay(1);
        }
        break;

      case 16:
        a1--;
        if (a1 < 0 || a1 >= AOW_BUILDINGCOUNT)
        {
            if (authed) { Print(s:"Invalid building index ", d:a1); }
            break;
        }

        a2--;

        if (a2 < 0 || a2 >= TEAMCOUNT) { j = team; }
        else { j = a2; }

        i = BuildingKillScripts[j][a1];
        ACS_ExecuteAlways(i, 0);

        if (authed) { Print(s:"Blowing up the ", s:TeamColorCodes[j], s:TeamNames[j], s:"\c- ", s:BuildingNames[a1], s:"."); }
        break;

      case 17:
        if (a1 < 1 || a1 > AOW_MWEPCOUNT)
        {
            TakeInventory("IsMech", 0x7FFFFFFF);
            if (authed) { Print(s:"You're no longer a mech."); }
        }
        else
        {
            GiveInventory("IsMech", 1);
            if (!authenticated[pln])
            {
                if (authed) { Print(s:"You are now a ", s:aowMechNames[a1-1], s:"."); }
            }
            else
            {
                if (authed) { Print(s:"You are now a ", s:aowMechNames[a1-1], s:".\nYou might want to 'puke -592 4'."); }
            }
        }

        for (i = 0; i < AOW_MWEPCOUNT; i++)
        {
            if (i == (a1-1))
            {
                GiveInventory(aowMechWeapons[i], 1);
                SetWeapon(aowMechWeapons[i]);
            }
            else
            {
                TakeInventory(aowMechWeapons[i], 0x7FFFFFFF);
            }
        }
        break;

      case 18:
        loopInfiniteAmmo[pln] = !loopInfiniteAmmo[pln];
        
        if (authed) { Print(s:"Infinite ammo is ", s:cond(loopInfiniteAmmo[pln], "\cdON", "\cgOFF"), s:"\c-."); }

        while (loopInfiniteAmmo[pln])
        {
            if (isDead(0)) { Delay(1); continue; }

            for (i = 0; i < AOW_AMMOCOUNT; i++)
            {
                j = aowAmmoTypes[i];
                k = CheckInventory(j);

                if (k < GetAmmoCapacity(j))
                {
                    GiveInventory(j, GetAmmoCapacity(j) - k);
                }
            }

            SetInventory("RemoteC4Ammo", 3);  // hack

            Delay(1);
        }

        loopInfiniteAmmo[pln] = 0;
        break;

      case 19:
        if (a1 < 1 || a1 > (AOW_OWEPCOUNT + AOW_IWEPCOUNT))
        {
            if (!authed) { break; }
            if (a1 != 0) { Print(s:"Invalid weapon index ", d:a1); break; }

            logStr = "";
            l = 0;
            SetHudSize(640, 480, 1);
            HudMessage(s:"Weapons:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 540.0, 34.0, 4.0, 1.0);

            for (i = 0; i < AOW_OWEPCOUNT; i++)
            {
                j = cond(l%2, CR_LIGHTBLUE, CR_WHITE);
                k = 50.0 + (l * 11.0);

                intStr = StrParam(d:l+1);
                logStr = StrParam(s:logStr, s:padStringR(intStr, " ", 2), s:" - ", s:aowOtherWeapons[i], s:"\n");

                HudMessage(d:l+1;  HUDMSG_FADEOUT, 49235+(l*3), CR_GOLD,  500.4, k, 4.0, 1.0);
                HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(l*3), CR_GREEN, 513.4, k, 4.0, 1.0);
                HudMessage(s:aowOtherWeapons[i]; HUDMSG_FADEOUT, 49237+(l*3), j, 520.1, k, 4.0, 1.0);
                
                l++;
            }

            for (i = 0; i < AOW_IWEPCOUNT; i++)
            {
                j = cond(l%2, CR_LIGHTBLUE, CR_WHITE);
                k = 50.0 + (l * 11.0);

                intStr = StrParam(d:l+1);
                logStr = StrParam(s:logStr, s:padStringR(intStr, " ", 2), s:" - ", s:aowWeaponItems[i], s:"\n");

                HudMessage(d:l+1;  HUDMSG_FADEOUT, 49235+(l*3), CR_GOLD,  500.4, k, 4.0, 1.0);
                HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(l*3), CR_GREEN, 513.4, k, 4.0, 1.0);
                HudMessage(s:aowWeaponItems[i]; HUDMSG_FADEOUT, 49237+(l*3), j, 520.1, k, 4.0, 1.0);
                
                l++;
            }

            HudMessage(s:logStr; HUDMSG_PLAIN|HUDMSG_LOG, 1, CR_WHITE, 0,0,0);
            HudMessage(s:""; HUDMSG_PLAIN, 1, CR_WHITE, 0,0,1);
            break;
        }

        a2 = max(1, a2);
        a1--;

        if (a1 >= AOW_OWEPCOUNT) { i = aowWeaponItems[a1 - AOW_OWEPCOUNT]; }
        else { i = aowOtherWeapons[a1]; }

        GiveInventory(i, a2);
        
        if (authed) { Print(s:"Giving ", d:a2, s:" of ", s:i); }
        break;

      case 20:
        if (a2 == 0) { a2 = pln; }
        else { a2--;} 

        if (a1 < 0 || a1 >= GetCVar("sv_maxteams"))
        {
            if (authed) { Print(s:"Team index ", d:a1, s:" out of range!"); }
            break;
        }

        if (!PlayerInGame(a2))
        {
            if (authed) { Print(s:"Player ", d:a2, s: "is not in the game."); }
            break;
        }
        
        if (!SetActivator(playerTIDs[a2]))
        {
            if (authed) { Print(s:"Selecting player ", n:a2+1, s:"\c- failed."); }
            break;
        }

        Player_SetTeam(a1);
		Log(n:0,s:" was changed to ", s:teamColorCodes[a1], s:teamNames[a1], s:"\c-.");

        switch (a1)
        {
          case 0:  // Blue
            Teleport(70);
            GiveInventory("HasClass",1);
            ACS_ExecuteAlways(95, 0);
            TakeInventory("IsRed",1);
            GiveInventory("IsBlue",1);
            break;

          case 1:
            Teleport(71);
            GiveInventory("HasClass",1);
            ACS_ExecuteAlways(95, 0);
            TakeInventory("IsBlue",1);
            GiveInventory("IsRed",1);
            break;
        }

        SetActivator(playerTIDs[pln]);
        if (authed) { Print(s:"Switched team of ", n:a2+1, s:"\c- to ", s:teamColorCodes[a1], s:teamNames[a1], s:"\c- successfully."); }
        break;
        
      default:
        if (authed)
        {
            HudMessage(s:NOSVPURE_AOW_HELP; HUDMSG_PLAIN | HUDMSG_LOG, 29100, CR_GOLD, 0.0, 0.0, 0.0);
            HudMessage(s:"See the console for help."; HUDMSG_PLAIN, 29100, CR_GOLD, 1.5, 0.47, 5.0);
        }
        break;
    }        
}

script 593 (int mode, int a1, int a2)
{
    int i, ret, newCache, cacheTop, cacheItem;

    switch (mode)
    {
      case 0:
        if (CheckInventory("IsRed")) { SetResultValue(2); break; }
        SetResultValue(1);
        break;
        
      case 1:
        if (a1 < 0 || a1 >= CACHEITEMC)
        {
            Log(s:"script 593: invalid cache item index ", d:a1);
            break;
        }
        cacheItem = cacheItems[a1];
        cacheTop  = cacheTops[a1];

        newCache = mod(CheckInventory(cacheItem) + 1, cacheTop);
        TakeInventory(cacheItem, CheckInventory(cacheItem));
        GiveInventory(cacheItem, newCache);

        switch (a1)
        {
            case 0: Print(s:cacheModes[newCache]); break;
            case 1: Print(s:geoModes[newCache]); break;
            case 2: Print(s:turretModes[newCache]); break;
            case 3: Print(s:mechModes[newCache]); break;
        }
        break;

      case 2:
        while (a1--)
        {
            SetActorProperty(0, APROP_Health, GetActorProperty(0, APROP_SpawnHealth));
            Delay(1);
        }
        break;

      case 3:
        ret = 0;
        for (i = 0; i < a2; i++) { ret += random(-a1, a1); }
        SetResultValue(ret);
        break;
    }
}
