int NOSVPURE_HELP = "Help for script 591:\n\
Usage: puke -591 [mode] [arg1] [arg2]\n\
\n\
Puke script -691 for a menu.\n\
\n\
Modes\n\
-----\n\
1  - Gives you a Doom weapon and ammo satchel, with arg1 as the weapon index. \n\
The weapon is Spawn'd and GiveInventory'd.\n\
2  - You get all Doom weapons, an ammo satchel for each, as well as the custom \n\
nosvpure weapons.\n
  arg1's meaning:\n\
    0 - Give Doom weapons directly, and spawn them at your feet.\n\
    1 - Give Doom weapons directly.\n\
    2 - Spawn Doom weapons at your feet.\n\
    3 - Do not give Doom weapons.\n\
    4 - Do not give NoSVPure weapons. Give Doom weapons directly.\n\
    5 - Do not give NoSVPure weapons. Spawn Doom weapons at your feet.\n\
\n\
3  - Sets your spawn health and current health, according to ((arg2 << 16) + \n\
arg1).\n\
4  - Same as 2, but just sets your health.\n\
5  - Sets your speed, with arg1 as the integral part and arg2 as the \n\
percentage.\n\
6  - Same as 4, but for JumpZ.\n\
7  - Toggles god mode. It's PowerProtection style - literally nothing can kill \n\
you.\n\
8  - Toggles invisibility. You are NOTARGET'd and RenderStyle None'd. Note that \n\
newly connecting players can see you.\n\
9  - Toggles instagib mode - ie. it multiplies your damage output by 10000.\n\
10 - Toggles NOINTERACTION mode - like noclip, but with literally no physics \n\
checks done on you.\n\
11 - Toggles health regeneration, with the amount of health you regenerate per \n\
second equal to arg1. If negative, damages you instead. If arg1 is negative and\n\
arg2 is non-zero, drains instead of damages.\n\
12 - Toggles 'wallhack' mode. Imagine the kickbans.\n\
13 - Checks your target's health.";

int NOSVPURE_HELP2 = " 14 - Sets the health of your target, killing, gibbing, and causing pain as \n\
appropriate. Note that boosting a monster's health over their max will make \n\
them friendly.\n\
15 - Gives you all the standard keys.\n\
16 - Toggles time freeze mode. Imagine the kickbans!\n\
17 - Heals your target for <arg1> HP. Supply arg2, and it'll be taken as a percentage\n\
of the target's max health - this will be used at the max for this script.\n\
The friendly effect for mode 14 applies here, too.\n\
18 - The same as 16, but for you. The friendly effect doesn't apply - why would it?\n\
19 - Summons a monster (puke it with no arguments for a list). Spawns friendly\n\
unless you pass in arg2.\n\
20 - Selects a nosvpure weapon, based off of arg1. If it's 0, it gives you a list.\n\
21 - Teleport immediately behind the player with player number <arg1>. If arg2 is\n\
non-zero, force the teleport. If it's positive, teleport behind the player for\n\
that many tics.\n\
22 - Set a point to teleport to, with arg1 as the index. If arg1 0, print the\n\
points that have been set. If arg2 is nonzero, delete the point instead.\n\
23 - Teleport to a teleport point. If arg1 is 0, print the available points.\n\
24 - If arg1 is 1, enable PROP_TOTALLYFROZEN. Otherwise, disable it.\n\
25 - Set gravity to x%, where x is (100*arg1) + arg2.\n\
26 - Toggle a rune. Without any arguments, prints the potential runes.\n\
27 - Flight! It defeats SetPlayerProperty(0, 0, PROP_FLIGHT), as well.\n\
28 - Give you teamgame points.\n\
29 - Give a sphere.";

#define AMMOCOUNT   4
#define WEPCOUNT    12
#define CWEPCOUNT   22
#define LWEPCOUNT   40
#define KEYCOUNT    6
#define MONCOUNT    18
#define RUNECOUNT   10
#define SPHERECOUNT 8

#define POINTCOUNT  256

#define AUTHCOUNT   6
#define AUTHLEVELCOUNT (AUTHCOUNT+2)/3

#define TARGET_CHECK    736

#define SPAWNDIST   96

#define CHECK_TID       1
#define CHECK_NAME      2
#define CHECK_TEAM      3
#define CHECK_HP        4
#define CHECK_MAXHP     5
#define CHECK_FRIEND    6

int weapons[WEPCOUNT] = {"Chainsaw", "Pistol", "Shotgun", "SuperShotgun", "Chaingun",  "RocketLauncher",  "PlasmaRifle",  "BFG9000", "Minigun", "GrenadeLauncher", "Railgun", "BFG10k"};
int wepAmmo[WEPCOUNT] = {"",         "Clip",   "Shell",   "Shell",        "Clip",      "RocketAmmo",      "Cell",         "Cell",    "Clip",    "RocketAmmo",      "Cell",    "Cell"};
int nosvAmmo[AMMOCOUNT]   = {"Clip", "Shell", "RocketAmmo", "Cell"};
int keys[KEYCOUNT] = {"BlueCard", "BlueSkull", "RedCard", "RedSkull", "YellowCard", "YellowSkull"};
int monsters[MONCOUNT] = {"ZombieMan", "ShotgunGuy", "ChaingunGuy", "DoomImp", "Demon", "Spectre", "Cacodemon", "Revenant", "HellKnight", "BaronOfHell", "Fatso", "Arachnotron", "LostSoul", "PainElemental", "Archvile", "Cyberdemon", "SpiderMastermind", "WolfensteinSS"};

int cWeps[CWEPCOUNT] = {"RailPistol", "RailChaingun", "NoSV - Healing Pistol", "NoSV - Pellet Spammer", "NoSV - Blame Shifter", "NoSV - Tagger", "Uber-Fist", "Uber-Chainsaw", "Uber-Pistol", "Uber-Shotgun", "Uber-Super Shotgun", "Uber-Chaingun", "Uber-Minigun", "Uber-Rocket Launcher", "Uber-Grenade Launcher", "Uber-Plasma Rifle", "Uber-Railgun", "Uber-BFG9000", "Uber-BFG10k", "Rotisserie Gun", "Rocket Jumper", "Instant-Rocket Jumper"};

int lelweps[LWEPCOUNT][3] =
{
    {"Jump Pads",               "",                 ""},
    {"Launcher Dagger",         "",                 ""},
    {"The Other Launcher Wand", "",                 ""},
    {"Trap Bonus",              "",                 ""},
    {"VorpalBlade",             "",                 ""},
    {"Quaker",                  "",                 ""},
    {"Healing Pistol",          "",                 ""},
    {"Gun Pistol",              "",                 ""},
    {"Launcher Pistol",         "",                 ""},
    {"Launcher Wand",           "",                 ""},
    {"Pist'O'l",                "",                 ""},
    {"Storm Bolter",            "",                 ""},
    {"Abortion Shotgun",        "",                 ""},
    {"Confetti Shotgun",        "",                 ""},
    {"Fireball Shotgun",        "",                 ""},
    {"Permaflamewall",          "",                 ""},
    {"Phalanx",                 "Shell",            "RocketAmmo"},
    {"Shotgun Breeder",         "",                 ""},
    {"Super Healgun",           "",                 ""},
    {"Super Noclip",            "",                 ""},
    {"Super Rocket Shotgun",    "",                 ""},
    {"Super Spheregun",         "",                 ""},
    {"Bolter",                  "",                 ""},
    {"Flame Chaingun",          "Clip",             ""},
    {"Drunk Rocket Launcher",   "",                 ""},
    {"ClusterGrenadeLauncher",  "",                 ""},
    {"FireGrenadeLauncher",     "",                 ""},
    {"WTRL",                    "ROFLRockets",      ""},
    {"DarkLauncher",            "",                 ""},
    {"Holowall Spawner",        "",                 ""},
    {"LGD1",                    "LaserCharge",      ""},
    {"TCBPR",                   "ROFLCell",         ""},
    {"Lasgun",                  "",                 ""},
    {"BlackHole_Generator",     "BHAmmo",           ""},
    {"Harbinger",               "",                 ""},
    {"IceAgeCannon",            "IceAgeAmmo",       ""},
    {"lul",                     "",                 ""},
    {"Powerful",                "RocketAmmo",       ""},
    {"IonCannon",               "Cell",             ""},
    {"Geo-Maker",               "",                 ""},
};

int runes[RUNECOUNT] = {"RuneDoubleDamage", "RuneDoubleFiringSpeed", "RuneDrain", "RuneSpread", "RuneHalfDamage", "RuneRegeneration", "RuneProsperity", "RuneReflection", "RuneHighJump", "RuneSpeed25"};
int spheres[SPHERECOUNT] = {"Soulsphere", "Megasphere", "Blursphere", "InvulnerabilitySphere", "Doomsphere", "Guardsphere", "InvisibilitySphere", "TimeFreezeSphere"};

int authNums[AUTHCOUNT];
int playerAuthNums[PLAYERMAX][AUTHCOUNT];

int authStage[PLAYERMAX]        = {0};
int successAuth[PLAYERMAX]      = {0};
int authenticated[PLAYERMAX]    = {0};

int loopInvuln[PLAYERMAX]       = {0};
int loopInvis[PLAYERMAX]        = {0};
int loopInstagib[PLAYERMAX]     = {0};
int loopNoclip[PLAYERMAX]       = {0};
int loopHeal[PLAYERMAX]         = {0};
int loopFreeze[PLAYERMAX]       = {0};
int loopSpy[PLAYERMAX]          = {0};
int loopTele[PLAYERMAX]         = {0};
int loopFly[PLAYERMAX]          = {0};
int playerTIDs[PLAYERMAX]       = {0};

int AlertAuth;
int IsServer;

int TeleportPoints[POINTCOUNT][4];

int TagScripts[PLAYERMAX][5];
int TagNag[PLAYERMAX];

#define CHOICECOUNT 30
#define MENU_SCREENX 640
#define MENU_SCREENY 480
#define MENU_SPACING 12

int MenuLevel[PLAYERMAX];

int ChoiceNames[CHOICECOUNT][3] = 
{
    {"Give Doom weapon",                    "Weapon index",     "Mode"},
    {"Give all Doom and NoSVPure weapons",  "Giving mode",      ""},
    {"Set spawn+current HP",                "HP",               "HP x 65536"},
    {"Set current HP",                      "HP",               "HP x 65536"},
    {"Set speed",                           "Integral part",    "Percent part"},
    {"Set jump height",                     "Integral part",    "Percent part"},
    {"Toggle god mode",                     "",                 ""},
    {"Toggle invisibility",                 "",                 ""},
    {"Toggle instagib mode",                "",                 ""},
    {"Toggle NOINTERACTION",                "",                 ""},
    {"Toggle health regeneration",          "HP per second",    "Flags"},
    {"Toggle 'wallhack' mode",              "",                 ""},
    {"Check health of target",              "",                 ""},
    {"Set health of target",                "HP",               "HP x 65536"},
    {"Give all keys",                       "",                 ""},
    {"Toggle time freeze",                  "",                 ""},
    {"Heal target",                         "HP",               "Max HP ( % )"},
    {"Heal yourself",                       "HP",               "Max HP ( % )"},
    {"Spawn a monster",                     "Monster index",    "Friendly"},
    {"Give a Lelwep",                       "Weapon index",     "Spawn at feet?"},
    {"Teleport behind a player",            "Player number",    ""},
    {"Set teleport point",                  "Point index",      "Delete?"},
    {"Go to teleport point",                "Point index",      "Silent?"},
    {"PROP_TOTALLYFROZEN",                  "Enable/disable",   ""},
    {"Set gravity",                         "Integral part",    "Percent part"},
    {"Runes",                               "Rune",             ""},
    {"Flight",                              "",                 ""},
    {"Give points",                         "Points",           ""},
    {"Give sphere",                         "Sphere index",     ""},
    {"Kick/ban IDX",                        "IDX - 1",          "Duration"},
};

int ChoiceArgLimits[CHOICECOUNT][2][2] = 
{
    {{0, WEPCOUNT+1},   {0, 3}},
    {{0, 6},            {0, 0}},
    {{-32768, 32768},   {-32768, 32767}},
    {{-32768, 32768},   {-32768, 32767}},
    {{-32768, 32768},   {0, 100}},
    {{-32768, 32768},   {0, 100}},
    {{0, 0},            {0, 0}},
    {{0, 0},            {0, 0}},
    {{0, 0},            {0, 0}},
    {{0, 0},            {0, 0}},
    {{-32768, 32768},   {0, 8}},
    {{0, 0},            {0, 0}},
    {{0, 0},            {0, 0}},
    {{-32768, 32768},   {-32768, 32767}},
    {{0, 0},            {0, 0}},
    {{0, 0},            {0, 0}},
    {{-32768, 32768},   {0, 32767}},
    {{-32768, 32768},   {0, 32767}},
    {{1, MONCOUNT+1},   {0, 2}},
    {{0, LWEPCOUNT+1},  {0, 3}},
    {{0, PLAYERMAX},    {0, 0}},
    {{0, POINTCOUNT+1}, {0, 2}},
    {{0, POINTCOUNT+1}, {0, 2}},
    {{0, 2},            {0, 0}},
    {{-32768, 32768},   {0, 100}},
    {{1, RUNECOUNT+1},  {0, 0}},
    {{0, 0},            {0, 0}},
    {{-32768, 32768},   {0, 0}},
    {{0, SPHERECOUNT+1},{0, 0}},
    {{0, 64},           {-1, 32768}},
};
