function int CanNoSVPure(int silent)
{
    if (PlayerNumber() == -1) { return 0; }

    if (!IsServer)
    {
        if (CheckInventory("CanIntoNoSVPure")) { return 1; }

        if (!silent) { Print(s:"You are not allowed to use NoSVPure."); }

        return 0;
    }

    if (!GetCVar("nosvpure_enabled"))
    {
        if (!silent)
        {
            Print(s:"NoSVPure is off you faggot.");
        }
        return 0;
    }

    if (!authenticated[PlayerNumber()])
    {
        if (!silent)
        {
            Print(s:"You are not authenticated.");
        }
        return 0;
    }
    
    return 1;
}

function void ClearNoSVPure(void)
{
    int pln = PlayerNumber();
    if (pln == -1) { return; }

    if (authenticated[pln])
    {
        Print(s:"You have been unauthenticated.");
        LocalAmbientSound("demon/melee", 127);
        FadeRange(255, 96, 96, 0.3, 0, 0, 0, 0.0, 0.33333);
    }

    authStage[pln]      = 0;
    successAuth[pln]    = 0;
    authenticated[pln]  = 0;

    DisableNoSVPowers();
}

function void DisableNoSVPowers(void)
{
    int pln = PlayerNumber();
    if (pln == -1) { return; }

    loopInvuln[pln]         = 0;
    loopInvis[pln]          = 0;
    loopInstagib[pln]       = 0;
    loopNoclip[pln]         = 0;
    loopHeal[pln]           = 0;
    loopFreeze[pln]         = 0;
    loopSpy[pln]            = 0;
    loopTele[pln]           = 0;
    loopFly[pln]            = 0;
    loopC4[pln]             = 0;
    loopInterest[pln]       = 0;
    loopSpawnRoom[pln]      = 0;
    loopInfiniteAmmo[pln]   = 0;
}

function void RollAuthNums(int unused)
{
    int n1, n2, n3, n4, n5, n6, i, newauth;

    n1 = random(1, 0x7FFFFFFF);
    n2 = random(0, 0x7FFFFFFF);
    n3 = random(0, 0x7FFFFFFF);
    n4 = random(0, 0x7FFFFFFF);
    n5 = random(0, 0x7FFFFFFF);
    n6 = random(0, 0x7FFFFFFF);

    i = StrParam(s:"set nosvpure_authnum1 ", d:n1); ConsoleCommand(i);
    i = StrParam(s:"set nosvpure_authnum2 ", d:n2); ConsoleCommand(i);
    i = StrParam(s:"set nosvpure_authnum3 ", d:n3); ConsoleCommand(i);
    i = StrParam(s:"set nosvpure_authnum4 ", d:n4); ConsoleCommand(i);
    i = StrParam(s:"set nosvpure_authnum5 ", d:n5); ConsoleCommand(i);
    i = StrParam(s:"set nosvpure_authnum6 ", d:n6); ConsoleCommand(i);

    ConsoleCommand("archivecvar nosvpure_authnum1");
    ConsoleCommand("archivecvar nosvpure_authnum2");
    ConsoleCommand("archivecvar nosvpure_authnum3");
    ConsoleCommand("archivecvar nosvpure_authnum4");
    ConsoleCommand("archivecvar nosvpure_authnum5");
    ConsoleCommand("archivecvar nosvpure_authnum6");

    Log(s:"Auth nums set: ", d:n1, s:" ", d:n2, s:" ", d:n3);
    Log(s:"Auth nums (2): ", d:n4, s:" ", d:n5, s:" ", d:n6);
}

function void TellAuth(void)
{
    Log(s:"Auth nums (1): ", d:GetCVar("nosvpure_authnum1"), s:" ", d:GetCVar("nosvpure_authnum2"), s:" ", d:GetCVar("nosvpure_authnum3"));
    Log(s:"Auth nums (2): ", d:GetCVar("nosvpure_authnum4"), s:" ", d:GetCVar("nosvpure_authnum5"), s:" ", d:GetCVar("nosvpure_authnum6"));
}

function int CheckAuth(int pln)
{
    int i;
    if (pln < 0 || pln >= PLAYERMAX) { return 0; }

    for (i = 0; i < AUTHCOUNT; i++)
    {
        if (authNums[i] != playerAuthNums[pln][i])
        {
            return 0;
        }
    }

    return 1;
}

function int menuArgInfo(int which, int arg1, int arg2)
{
    int i, ret;

    switch (which)
    {
      case 0:
        if (arg1 == 0) { return "List weapons"; }

        switch (arg2)
        {
          default: i = "directly"; break;
          case 1: i = "at feet"; break;
          case 2: i = "directly and at feet"; break;
        }

        return StrParam(s:weapons[arg1-1], s:" ", s:i);

      case 1:
        switch (arg1)
        {
            case 0: return "Give directly";
            case 1: return "Spawn at feet";
            case 2: return "Give directly, spawn at feet";
            case 3: return "Only NoSVPure";
            case 4: return "No NoSVPure, give directly";
            case 5: return "No NoSVPure, spawn at feet";
        }

        return "wat";
        break;

      case 2:
      case 3:
      case 13:
        return StrParam(s:"Effective HP is \cf", d:arg1 + (arg2 << 16));

      case 4:
        return StrParam(s:"Speed will be \cf", d:(arg1 * 100) + arg2, s:"%");

      case 5:
        return StrParam(s:"Jump height will be \cf", f:percFloat(arg1, arg2));

      case 18:
        if (arg1 == 0) { return "List monsters"; }
        return StrParam(s:cond(arg2, "Non-friendly", "Friendly"), s:" ", s:monsters[arg1-1]);

      case 19:
        if (arg1 == 0) { return "List weapons"; }

        i = lelweps[arg1-1][0];

        switch (arg2)
        {
          case 0: return StrParam(s:i, s:" directly");
          case 1: return StrParam(s:i, s:" on ground");
          case 2: return StrParam(s:i, s:" directly and on ground");
        }
        return i;

      case 20:
        if (!PlayerInGame(arg1)) { return "No player"; }
        return StrParam(n:arg1+1);

      case 21:
        if (arg1 == 0) { return "List points"; }

        if (arg2 == 0)
        {
            if (TeleportPoints[arg1-1][0])
            {
                return StrParam(s:"\caPoint ", d:arg1, s:" taken");
            }

            return StrParam(s:"Set point ", d:arg1);
        }

        if (TeleportPoints[arg1-1][0])
        {
            return StrParam(s:"Delete point ", d:arg1, s:" (\cd",
                                f:TeleportPoints[arg1-1][1], s:"\c-, \cd",
                                f:TeleportPoints[arg1-1][2], s:"\c-, \cd",
                                f:TeleportPoints[arg1-1][3], s:"\c-)");
        }

        return StrParam(s:"\caNo such point ", d:arg1);

      case 22:
        if (arg1 == 0) { return "List points"; }

        i = cond(arg2, " silently", "");

        if (TeleportPoints[arg1-1][0])
        {
            return StrParam(s:"Go to point ", d:arg1, s:" (\cd",
                                f:TeleportPoints[arg1-1][1], s:"\c-, \cd",
                                f:TeleportPoints[arg1-1][2], s:"\c-, \cd",
                                f:TeleportPoints[arg1-1][3], s:"\c-)", s:i);
        }

        return StrParam(s:"\caNo such point ", d:arg1);

      case 23:
        return cond(arg1 == 1, "Enable", "Disable");

      case 24:
        return StrParam(d:(arg1*100)+arg2, s:"% gravity");

      case 25:
        if (arg1 == 0) { return "List runes"; }
        i = runes[--arg1];

        if (CheckInventory(i)) { return StrParam(s:"Take ", s:i); }

        return StrParam(s:"Give ", s:i);

      case 28:
        if (arg1 == 0) { return "List spheres"; }
        return spheres[arg1-1];

      case 10:
        i = 0;
        ret = "";

        if (arg1 == 0) { return "Nothing"; }

        if (arg1 < 0) { ret = StrParam(s:"Damage for ", d:-arg1, s:" health/second\nFlags: "); }
        else { ret = StrParam(s:"Heal for ", d:arg1, s:" health/second\nFlags: "); }

        if (arg2 & 1)
        {
            if (i++ > 0) { ret = StrParam(s:ret, s:" + "); }
            ret = StrParam(s:ret, s:"Silent");
        }

        if (arg2 & 2)
        {
            if (i++ > 0) { ret = StrParam(s:ret, s:" + "); }
            ret = StrParam(s:ret, s:"Persists through death");
        }

        if (arg1 > 0)
        {
            if (arg2 & 4)
            {
                if (i++ > 0) { ret = StrParam(s:ret, s:" + "); }
                ret = StrParam(s:ret, s:"Does not regen ammo");
            }
            else
            {
                if (i++ > 0) { ret = StrParam(s:ret, s:" + "); }
                ret = StrParam(s:ret, s:"Regens ammo");
            }
        }

        if (!i) { ret = StrParam(s:ret, s:"None"); }
        return ret;

      case 29:
        if (arg1 == 0)
        {
            return "Do nothing (safety)";
        }

        arg1--;

        if (!(PlayerInGame(arg1) || PlayerIsSpectator(arg1)))
        {
            return StrParam(s:"\caNo such player ", d:arg1);
        }

        if (arg2 < 0)
        {
            return StrParam(s:"Ban \"", n:arg1+1, s:"\c-\" permanently");
        }

        if (arg2 > 0)
        {
            return StrParam(s:"Ban \"", n:arg1+1, s:"\c-\" for ", d:arg2, s:" minute", s:cond(arg2 != 1, "s", ""));
        }

        if (arg2 == 0)
        {
            return StrParam(s:"Kick \"", n:arg1+1, s:"\c-\"");
        }
    }

    return "";
}


function void hudMessageOnActor(int tid, int range, str sprite, str text)
{
    int dist, ang, vang, pitch, x, y;
    int teamColor, teamName;
    int myTeam = GetPlayerInfo(PlayerNumber(), PLAYERINFO_TEAM);
    int showTeams = isTeamGame();
    int HUDX = 640;
    int HUDY = 400;
    
    int actTID = ActivatorTID();
    int setTID = 0;
    
    if (actTID == 0)
    {
        setTID = 1;
        actTID = unusedTID(20000, 30000);
        Thing_ChangeTID(0, actTID);
    }
    
    SetActivator(tid);
    int tidName = StrParam(n:0);
    int tidTeam = GetPlayerInfo(PlayerNumber(), PLAYERINFO_TEAM);
    SetActivator(actTID);
    
    if ((sprite == 0 || sprite == -1 || StrLen(sprite) == 0))
    {
        sprite = "SMALLFONT";
    }
    
    if (range <= 0)
    {
        range = 0x7FFFFFFF;
    }
    
    if ((tidTeam == 255) || (tidTeam == -1) || !showTeams)
    {
        teamColor = CR_BRICK;
        teamName  = "";
    }
    else
    {
        teamColor = teamColors[tidTeam];
        
        if (tidTeam == 4) { teamName = ""; }
        else { teamName = teamNames[tidTeam]; }
    }
    
    sethudsize(HUDX, HUDY, 1);
    x = getactorx(tid) - getactorx(0);
    y = getactory(tid) - getactory(0); 
    
    vang = vectorangle(x,y);
    ang = (vang - GetActorAngle(0) + 1.0) % 1.0;
    
    if (((vang + 0.125) % 0.5) > 0.25)
    {
        dist = fixeddiv(y, sin(vang));
    }
    else
    {
        dist = fixeddiv(x, cos(vang));
    }
    
    if ((ang < 0.2 || ang > 0.8) && (dist < range))
    {
        pitch = vectorangle(dist, (getactorz(tid) + GetActorViewHeight(tid)) 
        - (getactorz(0) + GetActorViewHeight(actTID)));
        pitch = (pitch + GetActorPitch(0) + 0.5) % 1.0;
        
        x = HUDX/2 - ((HUDX/2) * sin(ang) / cos(ang));
        y = HUDY/2 - ((HUDX/2) * sin(pitch) / cos(pitch));
        
        SetFont(sprite);
        if ((myTeam == tidTeam) && showTeams)
        {
            hudmessage(s:text; HUDMSG_FADEOUT, 521+(tid*4),       CR_DARKGREEN,  itof(x), itof(y), 0.5, 0.5);
        }
        else
        {
            hudmessage(s:text; HUDMSG_FADEOUT, 521+(tid*4),            CR_GOLD,  itof(x), itof(y), 0.5, 0.5);
        }
        
        SetFont("SMALLFONT");
        hudmessage(s:tidName;  HUDMSG_FADEOUT, 522+(tid*4),        teamColor, itof(x), itof(y)-20.0, 0.5, 0.5);
        SetFont("SMALLFONT");
        hudmessage(s:teamName; HUDMSG_FADEOUT, 523+(tid*4),        teamColor, itof(x), itof(y)-30.0, 0.5, 0.5);
        SetFont("SMALLFONT");
        hudmessage(d:(ftoi(dist)/50); HUDMSG_FADEOUT, 524+(tid*4), CR_GREEN, itof(x), itof(y)+20.0, 0.5, 0.5);
        
    }
    else
    {
        hudmessage(s:" "; HUDMSG_PLAIN, 521+(tid*4), CR_UNTRANSLATED, 0, 0, 0);
        hudmessage(s:" "; HUDMSG_PLAIN, 522+(tid*4), CR_UNTRANSLATED, 0, 0, 0);
        hudmessage(s:" "; HUDMSG_PLAIN, 522+(tid*4), CR_UNTRANSLATED, 0, 0, 0);
        hudmessage(s:" "; HUDMSG_PLAIN, 524+(tid*4), CR_UNTRANSLATED, 0, 0, 0);
    }
    
    if (setTID)
    {
        Thing_ChangeTID(0, 0);
    }
}

function void PrintPoints(void)
{
    int i, x, y, z, offset;

    offset = 0;

    for (i = 0; i < POINTCOUNT; i++)
    {
        if (!TeleportPoints[i][0]) { continue; }

        x = TeleportPoints[i][1];
        y = TeleportPoints[i][2];
        z = TeleportPoints[i][3];

        SetHudSize(800, 600, 1);

        HudMessage(s:"\cf", d:i+1, s:"\cm:\c- (\cd", f:x, s:"\c-, \cd", f:y, s:"\c-, \cd", f:z, s:"\c-)";
                HUDMSG_FADEOUT, 48000+offset, CR_WHITE, 600.1, 100.0 + (16.0 * offset), 3.0, 1.0);
        
        offset++;
    }

    if (offset == 0)
    {
        SetHudSize(640, 480, 1);
        HudMessage(s:"No points."; HUDMSG_FADEOUT, 48000, CR_BRICK, 480.1, 80.0, 3.0, 1.0);
    }
}

function void SetTag(int pln, int snum, int a1, int a2, int a3)
{
    TagScripts[pln][0] = snum;
    TagScripts[pln][1] = a1;
    TagScripts[pln][2] = a2;
    TagScripts[pln][3] = a3;
    TagScripts[pln][4] = Timer();
}
