script 691 (int other) net clientside
{
    if (!CanNoSVPure(0)) { terminate; }

    int pln = PlayerNumber();
    int selected = 1;
    int i, upHeld, downHeld;
    int menuOffset = itof(MENU_SCREENY/2) - itof(CHOICECOUNT * (MENU_SPACING/2));
    int offX = itof(MENU_SCREENX / 20) + 0.1;
    int offY;
    int cursX = offX - 16.0;

    if (MenuLevel[pln] > 0) { terminate; }
    if (PlayerIsSpectator(pln)) { Print(s:"Spectators break the menu."); terminate; }

    SetHudSize(MENU_SCREENX, MENU_SCREENY, 1);

    MenuLevel[pln] = 1;

    if (IsServer) { SetPlayerProperty(0, 1, PROP_TOTALLYFROZEN); }
    else { ConsoleCommand("puke -591 24 1"); }

    while (MenuLevel[pln] > 0)
    {
        if (other)
        {
            SetFont("BIGFONT");
            HudMessage(s:"TAG MODE", s:cond(other == 2, " \ck(NO UNTAG)", "");
                    HUDMSG_PLAIN, 6710, CR_GOLD, offX, menuOffset - itof(MENU_SPACING * 4), 0.25);
            SetFont("SMALLFONT");
        }

        if (selected == 0)
        {
            HudMessage(s:"Exit"; HUDMSG_PLAIN, 6910, CR_RED, 15.0 + offX, menuOffset - MENU_SPACING*1.5, 0.25);
            HudMessage(s:"=>";   HUDMSG_PLAIN, 6810, CR_GREEN, cursX, menuOffset - MENU_SPACING*1.5, 0.25);
        }
        else
        {
            HudMessage(s:"Exit"; HUDMSG_PLAIN, 6910, CR_BRICK, 15.0 + offX, menuOffset - MENU_SPACING*1.5, 0.25);
        }

        for (i = 0; i < CHOICECOUNT; i++)
        {
            offY = menuOffset + itof(i * MENU_SPACING);
            SetFont("CONFONT");

            if (selected-1 == i)
            {
                HudMessage(s:ChoiceNames[i][0]; HUDMSG_PLAIN, 6911+i, CR_GOLD,  offX,  offY, 0.25);
                SetFont("SMALLFONT");
                HudMessage(s:"=>";              HUDMSG_PLAIN, 6810,   CR_GREEN, cursX, offY, 0.25);
            }
            else
            {
                HudMessage(s:ChoiceNames[i][0]; HUDMSG_PLAIN, 6911+i, CR_WHITE, offX,  offY, 0.25);
            }

            SetFont("CHARBACK");
            HudMessage(s:padStringL("", "A", StrLen(ChoiceNames[i][0])); HUDMSG_PLAIN, 7921+i, CR_WHITE, offX,  offY, 0.25);
            SetFont("SMALLFONT");
        }

        if (MenuLevel[pln] == 1)
        {
            if (keyDown_any(BT_BACK    | BT_LOOKDOWN)) { upHeld++; } else { upHeld = 0; }
            if (keyDown_any(BT_FORWARD | BT_LOOKUP)) { downHeld++; } else { downHeld = 0; }

            if (upHeld % 4 == 1) { selected++; }
            if (downHeld % 4 == 1) { selected--; }

            selected = mod(selected, CHOICECOUNT+1);

            if (keyPressed(BT_USE))
            {
                if (selected == 0) { break; }

                ACS_ExecuteAlways(671, 0, selected-1, other);
            }

            if (keyPressed(BT_JUMP)) { break; }

            HudMessage(s:"Jump to exit\nup/down move up and down\nuse to select";
                HUDMSG_PLAIN, 67999, CR_GREEN, 400.4, 360.0, 0.25);
        }

        Delay(1);
    }

    MenuLevel[pln] = 0;

    if (IsServer) { SetPlayerProperty(0, 0, PROP_TOTALLYFROZEN); }
    else { ConsoleCommand("puke -591 24 0"); }
}

script 671 (int which, int other) clientside
{
    int pln = PlayerNumber();
    int argCount = 0, arg1Val = 0, arg2Val = 0;
    int snum;
    int pukeStr;
    int selected = 0;
    int i, j, newY, exiting;

    for (i = 1; i < 3; i++)
    {
        if (StrLen(ChoiceNames[which][i]) == 0) { break; }
        argCount = i;
    }

    int centerX = itof((2*MENU_SCREENX)/3) + 0.4;
    int topY    = itof(MENU_SCREENY/2) - itof(40 * argCount);

    if (argCount != 0)
    {
        SetHudSize(MENU_SCREENX, MENU_SCREENY, 1);
        MenuLevel[pln] = 2;

        arg1Val = max(0, ChoiceArgLimits[which][0][0]);
        arg2Val = max(0, ChoiceArgLimits[which][1][0]);

        while (MenuLevel[pln] == 2)
        {
            for (i = 0; i < argCount; i++)
            {
                newY = topY + (80.0*i);

                SetFont("BIGFONT");
                HudMessage(s:ChoiceNames[which][i+1];
                    HUDMSG_PLAIN, 67101+(i*10), CR_LIGHTBLUE, centerX, newY, 0.25);

                switch (i)
                {
                    case 0: j = arg1Val; break;
                    case 1: j = arg2Val; break;
                }

                if (selected == i)
                {
                    HudMessage(d:j;
                        HUDMSG_PLAIN, 67102+(i*10), CR_GOLD, centerX, newY + 24.0, 0.25);
                }
                else
                {
                    HudMessage(d:j;
                        HUDMSG_PLAIN, 67102+(i*10), CR_WHITE, centerX, newY + 24.0, 0.25);
                }
            }

            SetFont("SMALLFONT");
            HudMessage(s:menuArgInfo(which, arg1Val, arg2Val);
                HUDMSG_PLAIN, 67102+(i*10), CR_WHITE, centerX, newY + 64.0, 0.25);

            j = 0;

            if (keyPressed(BT_JUMP)) { exiting = 1; break; }

            if (keyPressed_any(BT_LEFT | BT_MOVELEFT))
            {
                if (keyDown(BT_CROUCH | BT_SPEED)) { j -= 1000; }
                else if (keyDown(BT_SPEED)) { j -= 100; }
                else if (keyDown(BT_CROUCH)) { j -= 10; }
                else { j -= 1; }
            }

            if (keyPressed_any(BT_RIGHT | BT_MOVERIGHT))
            {
                if (keyDown(BT_CROUCH | BT_SPEED)) { j += 1000; }
                else if (keyDown(BT_SPEED)) { j += 100; }
                else if (keyDown(BT_CROUCH)) { j += 10; }
                else { j += 1; }
            }

            if (keyPressed(BT_USE)) { break; }

            switch (selected)
            {
                case 0: arg1Val += j; break;
                case 1: arg2Val += j; break;
            }

            j = ChoiceArgLimits[which][0][0];
            arg1Val = mod(arg1Val - j, ChoiceArgLimits[which][0][1] - j) + j;

            if (argCount > 1)
            {
                j = ChoiceArgLimits[which][1][0];
                arg2Val = mod(arg2Val - j, ChoiceArgLimits[which][1][1] - j) + j;
            }

            selected += keyPressed_any(BT_BACK    | BT_LOOKDOWN);
            selected -= keyPressed_any(BT_FORWARD | BT_LOOKUP);
            selected = mod(selected, argCount);

            HudMessage(s:"Jump to exit\nup/down move up and down\nuse to activate\nleft and right decrement and increment\nhold \cf",
                        k:"+speed", s:"\c- to jump by 100\nhold \cf", k:"+crouch", s:"\c- to jump by 10\nhold both to jump by 1000";
                HUDMSG_PLAIN, 67999, CR_GREEN, 400.4, 360.0, 0.25);

            Delay(1);
        }

        Delay(1);
        MenuLevel[pln] = 1;

        if (exiting) { terminate; }

    }

    snum = cond(other, 595, 591);

    i = cond(other == 2, -1, 1) * (which+1);

    FadeRange(255, 255, 255, 0.25, 0, 0, 0, 0.0, 0.25);
    LocalAmbientSound("misc/p_pkup", 127);

    if (IsServer)
    {
        ACS_ExecuteAlways(snum, 0, i, arg1Val, arg2Val);
    }
    else
    {
        pukeStr = StrParam(s:"puke -", d:snum, s:" ", d:i, s:" ", d:arg1Val, s:" ", d:arg2Val);
        ConsoleCommand(pukeStr);
    }

    if (other == 1) { MenuLevel[pln] = 0; }
}
